import os, sys, shutil, gzip
sys.path.append( "./src" )
from preferences import preferences

def copyfile( srcfile, dstfile ):
	dstdir = os.path.split(dstfile)[0]
	if not os.path.isdir( dstdir ):
		os.makedirs( dstdir )
	shutil.copy( srcfile, dstfile )

def copyfiles( srcdir, dstdir ):
	if not os.path.isdir( dstdir ):
		os.makedirs( dstdir )
	for file in os.listdir( srcdir ):
		if not os.path.isdir( srcdir + "/" + file ):
			shutil.copy( srcdir + "/" + file, dstdir + "/" + file )

def copygzip( srcfile, dstfile ):
	os.system("gzip "+srcfile )
	shutil.copy( srcfile+".gz", dstfile )
	os.system("gzip -d "+srcfile+".gz")

#	dstdir = os.path.split(dstfile)[0]
#	if not os.path.isdir( dstdir ):
#		os.makedirs( dstdir )
#	srcfid = open( srcfile, "r" )
#	dstfid = open( dstfile, "w" )
#	dstfid.write( srcfid.read() )
# WHERE THE FUCK IS THE GZIP BIT??!?!?
#	dstfid.close()
#	srcfid.close()
	
def copypacks( repo_root, dstdir ):
	'''
	Tar and gzip each folder in repo_root into component filename for use in
	extracting
	'''
	pass

def usage( error=None ):
	if error:
		print "Error: " + error
	print "Usage: python setup.py [command] <options>"
	print " Commands:"
	print "   install - installs wine-doors"
	print " uninstall - uninstalls wine-doors"
	print "	--help - display this usage message (default)\n"
	print " Options:"
	print "  --prefix - prefix path default /usr"
	sys.exit(0)
	pass
	
def symlink( srclink, dstlink ):
	dstdir = os.path.split(dstlink)[0]
	if not os.path.isdir( dstdir ):
		os.makedirs( dstdir )
	if not os.path.islink( dstlink ):
		os.symlink( srclink, dstlink )

if __name__ == "__main__":
	command = None
	for argument in sys.argv:
		if argument == "install" or argument == "uninstall":
			command = argument
		if argument.startswith( "--prefix" ):
			prefix = argument.split( "=" )[1]
		else:
			prefix = "/usr/"
		if argument.startswith( "--help" ):
			usage()
		if argument.startswith( "-S" ):
			sysinstall = True;
		else:
			sysinstall = False;

	if command == "install":
		if os.environ['USER'] == "root" or sysinstall:
			print "Performing system install"
			share = prefix + "share/wine-doors/"
			conf_file = "/etc/wine-doors/preferences.xml"
			copyfile( "./dist/wine-doors.desktop",  prefix + "share/applications/wine-doors.desktop" )		
		else:
			print "Performing user install"
			prefix = os.path.expanduser( "~/" )
			local = os.path.expanduser( "~/.local/")
			share = prefix + ".wine-doors/"
			conf_file = os.path.expanduser( "~/.winedoors.xml" )
			copyfile( "./dist/wine-doors.desktop", local + "share/applications/wine-doors.desktop" )		
	  
	  	print "Compressing and installing pack files"
		if not os.path.isdir( share + "base.repo" ):
			os.makedirs( share + "base.repo/" )
		if not os.path.isdir( share + "global.repo" ):
			os.makedirs( share + "global.repo" )
		copygzip( "./repos/base.repo/packlist.xml", share + "base.repo/packlist.xml.gz" )
		copypacks( "./repos/base.repo/", share + "global.repo/" )
		print "  ** Base Repo"
		copygzip( "./repos/global.repo/packlist.xml", share + "global.repo/packlist.xml.gz" )
		print "  ** Global Repo"
		copypacks( "./repos/global.repo/", share + "global.repo/" )
		copyfiles( "./src", share + "src" )
		copyfiles( "./pixmaps", share + "pixmaps" )
		copyfiles( "./dtd", share + "dtd" )

		print "Symlinking resources"
		if os.environ['USER'] == "root":
			if not os.path.isdir( "/etc/wine-doors" ):
				os.makedirs( "/etc/wine-doors" )
			symlink( share + "pixmaps/wine-doors.png", prefix + "/share/pixmaps/wine-doors.png" )
			symlink( share + "pixmaps/wine-doors.svg", prefix + "/share/pixmaps/wine-doors.svg" )
		
		symlink( share + "src/winedoors.py", prefix + "/bin/wine-doors" )
		print "Creating initial preferences"
		preferences.preferences['prefix'] = prefix
		preferences.Default()
		preferences.AddRepo( "System Global", share + "global.repo/" )
		preferences.AddRepo( "System Base", share +  "base.repo/" )
		preferences.Save( conf_file )
	elif command == "uninstall":
		if os.path.exists( prefix + "/bin/wine-doors" ):
			os.remove( prefix + "/bin/wine-doors" )
		if os.environ['USER'] == "root" or sysinstall:
			print "Removing system wide preferences"
			if not prefix:
				preferences.Load( "/etc/wine-doors/preferences.xml" )
				prefix = preferences['prefix']
			share = prefix + "share/wine-doors"
			if os.path.exists( "/etc/wine-doors" ):
				shutil.rmtree( "/etc/wine-doors" )
			print "Removing symlinks"
			if os.path.exists( prefix + "share/pixmaps/wine-doors.png" ):
				os.remove( prefix + "share/pixmaps/wine-doors.png" )
			if os.path.exists( prefix + "share/pixmaps/wine-doors.png" ):
				os.remove( prefix + "share/pixmaps/wine-doors.svg" )
			print "Removing menu item"
			if os.path.exists( prefix + "share/applications/wine-doors.desktop" ):
				os.remove (prefix + "share/applications/wine-doors.desktop" )
		else:
			prefix = os.path.expanduser( "~/" )
			share = prefix + ".wine-doors/"
			local = os.path.expanduser( "~/.local/")
			print "Removing menu item"
			if os.path.exists( local + "share/applications/wine-doors.desktop" ):
				os.remove ( local + "share/applications/wine-doors.desktop" )
		print "Removing shared data"
		if os.path.isdir( share ):
			shutil.rmtree( share, True )	
	else:
		usage("No command specified")
