import gtk, gobject
import sys, os, urllib

from const import *

from preferences import preferences
from packlist import packlist
from queue import queue
from wine import wine
from log import log

def ReposFromModel(model, path, iter ):
    name = model.get_value( iter, REPO_NAME )
    uri = model.get_value( iter, REPO_URI )
    packlist.AddRepo( name, uri )

def SetProgress( percentage, type=POPUP, text=None, widget=None ):
    pass

# Todo: remove deprecated code, there is a lot of it now, mostly moved to GH_main
class GladeHandlers:
    #-------------------------------#
    #          Main window          #
    #-------------------------------#
    def on_tbn_update_clicked ( widget, data=None ):
        packlist.UpdateAll()
        #
    
    # Deprecate
    def on_tbn_list_browser_clicked( widget, data=None ):
        global packlist
        global in_queue
        global window
        in_queue = False
        window['tv_packlist'].set_model( packlist.CreateTreeModel() )
        window['nb_infopane'].set_current_page( 0 )
    # Deprecate    
    def on_tbn_queue_clicked( widget, data=None ):
        global queue
        global in_queue
        global window
        in_queue = True
        window['tv_packlist'].set_model( queue.CreateTreeModel() )
        window['nb_infopane'].set_current_page( 2 )
    # Deprecate
    def on_tbn_cedega_purchase_clicked( widget, data=None ):
        pass
    # Deprecate
    def on_tbn_crossover_purchase_clicked( widget, data=None ):
        pass
    
    #------------------------------------#
    #          Application info          #
    #------------------------------------#
    def on_cbb_version_changed( widget, data=None ):
        return
        
    def on_bt_add_to_queue_clicked( widget, data=None ):
        global queue
        global pack
        queue.Add( "install", pack )
        return
        
    def on_bt_process_queue_clicked( widget, data=None ):
        return
    
    #-------------------------------#
    #          Main window          #
    #-------------------------------#
    
    # THIS IS ALL DUPLICATED FOR NOW, DEPRECATE THIS COPY!!
    def on_update_package_list_activate ( widget, data=None ):
        return
        
    def on_cache_files_activate ( widget, data=None ):
        return
        
    def on_view_wine_processes_activate ( widget, data=None ):
        global wineproc
        try:
            wineproc['wn_wineproc'].show()
        except:
            wineproc = Window( "wn_wineproc" )
            
    def on_kill_all_wine_processes_activate ( widget, data=None ):
        wine.Kill()
        
    def on_reboot_wine_activate ( widget, data=None ):
        wine.Reboot()
        
    def on_quit_activate( widget, data=None ):
        gtk.main_quit()
        
    def on_preferences_activate( widget, data=None ):
        global wn_prefs
        try:
            wn_prefs['wn_prefs'].show()
        except:
            wn_prefs = Window( "wn_prefs" )
            column = gtk.TreeViewColumn( 'Repository Name', gtk.CellRendererText(), text=REPO_NAME )
            column.set_sort_column_id( REPO_NAME )
            wn_prefs['tv_repos'].append_column( column )
            
            column = gtk.TreeViewColumn( 'Repository URI', gtk.CellRendererText(), text=REPO_URI )
            column.set_sort_column_id( REPO_URI )
            wn_prefs['tv_repos'].append_column( column )
            
        wn_prefs['file_wineroot'].set_current_folder( preferences['wineroot'] )
        wn_prefs['ck_updateonstart'].set_active( eval( preferences['updateonstart'] ) )
        wn_prefs['ck_cvscedega'].set_active( eval( preferences['cvscedega'] ) )
        wn_prefs['ck_cedega'].set_active( eval( preferences['cedega'] ) )
        wn_prefs['ck_crossover'].set_active( eval( preferences['crossover'] ) )
        wn_prefs['ck_licensed'].set_active( eval( preferences['licensed'] ) )
        wn_prefs['en_name'].set_text( preferences['name' ] )
        wn_prefs['en_company'].set_text( preferences['company'] )       
        
        # Repo list store
        model = gtk.ListStore( gobject.TYPE_STRING, 
                               gobject.TYPE_STRING )
        for item in preferences.repositories:
            iter = model.append()
            model.set( iter, 
                      REPO_NAME, item[REPO_NAME], 
                      REPO_URI, item[REPO_URI] )
            
        wn_prefs['tv_repos'].set_model( model )
        wn_prefs['tv_repos'].set_search_column( REPO_NAME )
    
    
    # Move this to GH_Main
    # Deprecated!
    def on_tv_packlist_cursor_changed( widget, data=None ):
        global pack
        global window
        iter = window['tv_packlist'].get_selection().get_selected()[1]
        model = window['tv_packlist'].get_model()
        shortname = model.get_value( iter, PACK_SHORTNAME )
        for item in packlist.available:
            if item["shortname"] == shortname:
                pack = item
                break
        # Start setting the UI variables
        window['lb_app_name1'].set_markup( "<b><big>" + pack["name"] + "</big></b>" )
        window['lb_app_name2'].set_markup( "<b><big>" + pack["name"] + "</big></b>" )
        window['lb_vendor'].set_text( pack["vendor"] )
        window['lb_homepage'].set_text( pack['homepage'] )
        window['lb_category'].set_text( pack['category'] )
        text_buffer = window['tx_description'].get_buffer()
        text_buffer.set_text( pack['description'] )
        window['tx_description'].set_buffer( text_buffer )
        versions = pack['versions']
        window['cbb_version'].set_model( gtk.ListStore( gobject.TYPE_STRING ) )
        index = 0
        for item in versions:
            window['cbb_version'].append_text( item )
            try:
                if item == pack["default_version"]:
                    window['cbb_version'].set_active( index )
            except:
                window['cbb_version'].set_active( 0 )
            index = index+1
        
        if "icon" in pack:
            icon_url = pack['icon'].split( "/" )
        
        icon_file = icon_url[len( icon_url )-1]
        icon_file = preferences['wineroot'] + "/wine-doors/icons/" + icon_file
        
        if not os.path.isfile( icon_file ):
            urllib.urlretrieve( pack['icon'], icon_file )
        
        window['im_icon1'].set_from_file( icon_file )
        window['im_icon2'].set_from_file( icon_file )
        window['nb_infopane'].set_current_page( 1 )
        
    def on_wine_version_activate( widget, data=None ):
        pass
    def on_contents_activate( widget, data=None ):
        pass
    def on_about_activate( widget, data=None ):
        global about
        try: about['wn_about'].show()
        except: about = Window( "wn_about" )
        
    #-------------------------#
    #          About          #
    #-------------------------#
    def on_bt_close_about_clicked( widget, data=None ):
        global about
        about['wn_about'].hide()
    def on_bt_about_credits_clicked( widget, data=None ):
        global credits
        try: credits['wn_credits'].show()
        except: credits = Window( "wn_credits" )
    def on_bt_credits_close_clicked( widget, data=None ):
        credits['wn_credits'].hide()
    
    #-----------------------------#
    #          Wine Proc          #
    #-----------------------------#
    def on_bt_kill_proc_clicked ( widget, data=None ):
        return
    def on_bt_close_wineproc_clicked ( widget, data=None ):
        global wineproc
        wineproc['wn_wineproc'].hide() 
    
    #-------------------------------#
    #          Preferences          #
    #-------------------------------#
    def on_bt_delete_repo_clicked( widget, data=None ):
        global wn_prefs
        selection = wn_prefs['tv_repos'].get_selection()
        item = selection.get_selected()
        if item:
            item[0].remove( item[1] )

    def on_bt_add_repo_clicked( widget, data=None ):
        global wn_prefs
        repo_name = wn_prefs['en_repo_name'].get_text()
        wn_prefs['en_repo_name'].set_text( "" )
        repo_uri = wn_prefs['en_repo_uri'].get_text()
        wn_prefs['en_repo_uri'].set_text( "" )
        model = wn_prefs['tv_repos'].get_model()
        #FIXME: model may be None
        if repo_name == "" or repo_uri == "":
            return
        iter = model.append()
        model.set( iter, 
                  REPO_NAME, repo_name, 
                  REPO_URI, repo_uri )
    def on_bt_prefs_cancel_clicked( widget, data=None ):
        global wn_prefs
        wn_prefs['wn_prefs'].hide()
    def on_bt_prefs_ok_clicked( widget, data=None ):
        global wn_prefs
        preferences['wineroot']      = wn_prefs['file_wineroot'].get_current_folder()
        preferences['updateonstart'] = wn_prefs['ck_updateonstart'].get_active()
        preferences['cvscedega']     = wn_prefs['ck_cvscedega'].get_active()
        preferences['cedega']        = wn_prefs['ck_cedega'].get_active()
        preferences['crossover']     = wn_prefs['ck_crossover'].get_active() 
        preferences['licensed']      = wn_prefs['ck_licensed'].get_active()
        preferences['name']          = wn_prefs['en_name'].get_text()
        preferences['company']       = wn_prefs['en_company'].get_text()
        model = wn_prefs['tv_repos'].get_model()
        model.foreach( preferences.ReposFromModel )
        preferences.Save()
        wn_prefs['wn_prefs'].hide()
        
    #-----------------------------#
    #          First run          #
    #-----------------------------#
    def on_bt_proceed_clicked( widget, data=None ):
        preferences["name"]     = window['en_name'].get_text()
        preferences["company"]  = window['en_company'].get_text()
        preferences['licensed'] = window['ck_licensed'].get_active()
        preferences.Save()
        queue.SetProgress()
        gobject.idle_add( queue.Execute( True ).next )
        
    def on_firstrun_cancel_clicked( widget, data=None ):
        gtk.main_quit()
        sys.exit( 0 )
    def quit( widget, data=None ):
        log.Debug( "Quit called" )
        gtk.main_quit()
    #-----------------------------#
    #    Error handling dialogs   #
    #-----------------------------#
    def CantLocateCD( widget, data=None ):
        pass
    def Messages ( widget, data=None ):
        global wn_errors
        if log.errors:
            try:
                wn_errors['wn_errors'].show()
            except:
                wn_errors = Window( "wn_errors" )
        else:
            return
        if log.errors:
            error_text = "<b>The following errors have been reported</b>\n"
            error_text += log.GetErrors()
        wn_errors['errors'].set_text( error_text )
    #-----------------------------#
    #    Generic Installer        #
    #-----------------------------#
    def GenericInstall ( widget, data=None ):
        global wn_generic_installmodel
        try:
            wn_generic_install['wn_generic_instrall'].show()
        except:
            wn_generic_install = Window( "wn_generic_install" )



class GH_Main: # These will probably be merged into the WineDoorsGUI class
    def quit( widget, data=None ):
        log.Debug( "Quit called" )
        gtk.main_quit()

    # Buttons
    def on_bn_update_clicked ( widget, data=None ):
        packlist.UpdateAll()
    
    # Menu
    def on_update_package_list_activate ( widget, data=None ):
        return
        
    def on_cache_files_activate ( widget, data=None ):
        return
        
    def on_view_wine_processes_activate ( widget, data=None ):
        global wineproc
        try:
            wineproc['wn_wineproc'].show()
        except:
            wineproc = Window( "wn_wineproc" )
            
    def on_kill_all_wine_processes_activate ( widget, data=None ):
        wine.Kill()
        
    def on_reboot_wine_activate ( widget, data=None ):
        wine.Reboot()
        
    def on_quit_activate( widget, data=None ):
        gtk.main_quit()
        
    def on_preferences_activate( widget, data=None ):
        global wn_prefs
        try:
            wn_prefs['wn_prefs'].show()
        except:
            wn_prefs = Window( "wn_prefs" )
            column = gtk.TreeViewColumn( 'Repository Name', gtk.CellRendererText(), text=REPO_NAME )
            column.set_sort_column_id( REPO_NAME )
            wn_prefs['tv_repos'].append_column( column )
            
            column = gtk.TreeViewColumn( 'Repository URI', gtk.CellRendererText(), text=REPO_URI )
            column.set_sort_column_id( REPO_URI )
            wn_prefs['tv_repos'].append_column( column )
            
        wn_prefs['file_wineroot'].set_current_folder( preferences['wineroot'] )
        wn_prefs['ck_updateonstart'].set_active( eval( preferences['updateonstart'] ) )
        wn_prefs['ck_cvscedega'].set_active( eval( preferences['cvscedega'] ) )
        wn_prefs['ck_cedega'].set_active( eval( preferences['cedega'] ) )
        wn_prefs['ck_crossover'].set_active( eval( preferences['crossover'] ) )
        wn_prefs['ck_licensed'].set_active( eval( preferences['licensed'] ) )
        wn_prefs['en_name'].set_text( preferences['name' ] )
        wn_prefs['en_company'].set_text( preferences['company'] )       
        
        # Repo list store
        model = gtk.ListStore( gobject.TYPE_STRING, 
                               gobject.TYPE_STRING )
        for item in preferences.repositories:
            iter = model.append()
            model.set( iter, 
                      REPO_NAME, item[REPO_NAME], 
                      REPO_URI, item[REPO_URI] )
            
        wn_prefs['tv_repos'].set_model( model )
        wn_prefs['tv_repos'].set_search_column( REPO_NAME )

    def on_wine_version_activate( widget, data=None ):
        pass
    def on_contents_activate( widget, data=None ):
        pass
    def on_about_activate( widget, data=None ):
        global about
        try: about['wn_about'].show()
        except: about = Window( "wn_about" )

    # Filter & Display
    
    # Tree
    def on_tv_packlist_cursor_changed( widget, data=None ):
        global pack
        global window
        iter = window['tv_packlist'].get_selection().get_selected()[1]
        model = window['tv_packlist'].get_model()
        shortname = model.get_value( iter, PACK_SHORTNAME )
        for item in packlist.available:
            if item["shortname"] == shortname:
                pack = item
                break
        # Start setting the UI variables
        window['lb_app_name'].set_markup( "<b><big>" + pack["name"] + "</big></b>" )
        #window['lb_app_name2'].set_markup("<b><big>" + pack["name"] + "</big></b>")
        window['lb_vendor'].set_text( pack["vendor"] )
        window['lb_homepage'].set_text( pack['homepage'] )
        window['lb_category'].set_text( pack['category'] )
        #text_buffer = window['tx_description'].get_buffer()
        #text_buffer.set_text(pack['description'])
        window['lb_description'].set_text( pack['description'] )
        #versions = pack['versions']
        #window['cbb_version'].set_model(gtk.ListStore(gobject.TYPE_STRING))
        #index = 0
        #for item in versions:
        #    window['cbb_version'].append_text(item)
        #    try:
        #        if item == pack["default_version"]:
        #            window['cbb_version'].set_active(index)
        #    except:
        #        window['cbb_version'].set_active(0)
        #    index = index+1
        
        if "icon" in pack:
            icon_url = pack['icon'].split( "/" )
        
        icon_file = icon_url[len( icon_url )-1]
        icon_file = preferences['wineroot'] + "/wine-doors/icons/" + icon_file
        
        if not os.path.isfile( icon_file ):
            urllib.urlretrieve( pack['icon'], icon_file )
        
        window['im_icon'].set_from_file( icon_file )
        #window['im_icon2'].set_from_file(icon_file)
        #window['nb_infopane'].set_current_page(1)

# This has been borrowed for a moment from pychess, thanks thomas.
# I'm just using it as a template.

class WDTileCellRenderer ( gtk.GenericCellRenderer ):
    __gproperties__ = {
        "data": ( gobject.TYPE_PYOBJECT, "Data", "Data", gobject.PARAM_READWRITE ), 
    }
   
    def __init__( self ):
        self.__gobject_init__()
        self.data = None
        
    def do_set_property( self, pspec, value ):
        setattr( self, pspec.name, value )
        
    def do_get_property( self, pspec ):
        return getattr( self, pspec.name )
        
    def on_render( self, window, widget, background_area, cell_area, expose_area, flags ):
        if not self.data: return
        cairo = window.cairo_create()
        icon_file, title_text, short_description, rating, buttons = self.data
        #paintTile( cairo, icon_file, title_text, short_description, rating, buttons )
        
        #w,d,l = self.data
        #paintGraph(cairo, w, d, l, cell_area)
       
    def on_get_size( self, widget, cell_area=None ):
        return ( 0, 0, width, height )
            
gobject.type_register( WDTileCellRenderer )

from math import ceil
#class Tile:

# The tree design will change drastically, this is where all of that handling
# should be done
class PackTree:
    def __init__( self, widget ):
    	log.Debug("Creating a packtree")
        # This is just for testing
        packlist.Update( "System Base" )
        #if preferences['updateonstart']:
        #    packlist.UpdateAll()

        self.model = gtk.ListStore( gobject.TYPE_BOOLEAN, 
                                   gobject.TYPE_STRING, 
                                   gobject.TYPE_STRING )
        

        
        renderer = gtk.CellRendererToggle()
        renderer.set_property( "xalign", 0.0 )
        renderer.set_data( "column", PACK_STATUS )

        renderer.connect( "toggled", self.on_item_toggled, self.model )

        column = gtk.TreeViewColumn( "", renderer, active=PACK_STATUS )

        #column = treeview.get_column(col_offset - 1)
        column.set_sizing( gtk.TREE_VIEW_COLUMN_FIXED )
        column.set_fixed_width( 50 )
        column.set_clickable( True )

        widget.append_column( column )
        
        
        
        column = gtk.TreeViewColumn( 'Application', gtk.CellRendererText(), text=PACK_NAME )
        column.set_sort_column_id( PACK_NAME )
        widget.append_column( column )
        
        column = gtk.TreeViewColumn( 'shortname', gtk.CellRendererText(), text=PACK_SHORTNAME )
        column.set_sort_column_id( PACK_SHORTNAME )
        column.set_visible( False )
        widget.append_column( column )
            
        widget.set_model( self.CreateModel( packlist.packs ) )
        widget.set_search_column( PACK_NAME )
        
    def on_item_toggled( self, cell, path_str, model ):
        print "Toggle"
        pass
    
    def CreateModel( self, packs, queue=False ):
        if not packs:
            packs = packlist.available
            
        for item in packs:
            if queue:
                action, pack = item
            else:
                pack = item
            iter = self.model.append()
            self.model.set( iter, PACK_STATUS, True, PACK_NAME, pack["name"], 
                             PACK_SHORTNAME, pack['shortname'] )
            log.Debug("Pack Name:" + pack['name'] + ", ui.py" )
        return self.model

class WineDoorsGUI:
    def __init__( self ):
        self.window = Window( "wn_winedoors", GH_Main )
        self.window['cb_display'].set_active(0)
        self.window['cb_filter'].set_active(0)
        self.PopulateFilter()
        self.tree = PackTree( self.window['tv_packlist'] )
    def __getitem__( self, key ):
        if key == "window":
            return self.window['wn_winedoors']
        return self.window[ key ]
    def PopulateFilter( self ):
    	# Create a list of relevent options from the filter selection
    	# populate the combo entry drop down list
    	pass

class Window:
    def __init__( self, window_name, Handlers=None ):
        glade = os.path.join( sys.path[0], 'winedoors.glade')
        self.widgets = gtk.glade.XML( glade, window_name )
        if not Handlers:
            Handlers = GladeHandlers
        self.widgets.signal_autoconnect( Handlers.__dict__ )
        self.window_init( window_name )
        
    def __getitem__( self, key ):
        return self.widgets.get_widget( key )
    
    # Deprecate this hackish nonsense
    def window_init ( self, window_name ):
        global window
        window = self
        if window_name == "wn_packlist":
            packlist.Update( "System Base" )
            column = gtk.TreeViewColumn( 'Application', gtk.CellRendererText(), text=PACK_NAME )
            column.set_sort_column_id( PACK_NAME )
            self['tv_packlist'].append_column( column )
            column = gtk.TreeViewColumn( 'shortname', gtk.CellRendererText(), text=PACK_SHORTNAME )
            column.set_sort_column_id( PACK_SHORTNAME )
            column.set_visible( False )
            self['tv_packlist'].append_column( column )
            
            self['tv_packlist'].set_model( packlist.CreateTreeModel() )
            self['tv_packlist'].set_search_column( PACK_NAME )
            
if __name__ == "__main__":
    windoors = WineDoorsGUI()
    gtk.main()
